const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class BillsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.create(
      {
        id: data.id || undefined,

        invoice_no: data.invoice_no || null,
        invoice_date: data.invoice_date || null,
        due_date: data.due_date || null,
        amount: data.amount || null,
        currency: data.currency || null,
        category: data.category || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await bills.setVendor(data.vendor || null, {
      transaction,
    });

    await bills.setOrganizations(data.organizations || null, {
      transaction,
    });

    return bills;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const billsData = data.map((item, index) => ({
      id: item.id || undefined,

      invoice_no: item.invoice_no || null,
      invoice_date: item.invoice_date || null,
      due_date: item.due_date || null,
      amount: item.amount || null,
      currency: item.currency || null,
      category: item.category || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const bills = await db.bills.bulkCreate(billsData, { transaction });

    // For each item created, replace relation files

    return bills;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const bills = await db.bills.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.invoice_no !== undefined)
      updatePayload.invoice_no = data.invoice_no;

    if (data.invoice_date !== undefined)
      updatePayload.invoice_date = data.invoice_date;

    if (data.due_date !== undefined) updatePayload.due_date = data.due_date;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.currency !== undefined) updatePayload.currency = data.currency;

    if (data.category !== undefined) updatePayload.category = data.category;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await bills.update(updatePayload, { transaction });

    if (data.vendor !== undefined) {
      await bills.setVendor(
        data.vendor,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await bills.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return bills;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of bills) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of bills) {
        await record.destroy({ transaction });
      }
    });

    return bills;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.findByPk(id, options);

    await bills.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await bills.destroy({
      transaction,
    });

    return bills;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const bills = await db.bills.findOne({ where }, { transaction });

    if (!bills) {
      return bills;
    }

    const output = bills.get({ plain: true });

    output.payments_bill = await bills.getPayments_bill({
      transaction,
    });

    output.vendor = await bills.getVendor({
      transaction,
    });

    output.organizations = await bills.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.vendors,
        as: 'vendor',

        where: filter.vendor
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.vendor
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.vendor
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.invoice_no) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'invoice_no', filter.invoice_no),
        };
      }

      if (filter.currency) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'currency', filter.currency),
        };
      }

      if (filter.category) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('bills', 'category', filter.category),
        };
      }

      if (filter.invoice_dateRange) {
        const [start, end] = filter.invoice_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            invoice_date: {
              ...where.invoice_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            invoice_date: {
              ...where.invoice_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.due_dateRange) {
        const [start, end] = filter.due_dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            due_date: {
              ...where.due_date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            due_date: {
              ...where.due_date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.bills.findAndCountAll(queryOptions);

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('bills', 'invoice_no', query),
        ],
      };
    }

    const records = await db.bills.findAll({
      attributes: ['id', 'invoice_no'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['invoice_no', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.invoice_no,
    }));
  }
};
